/* 
 *   Creation Date: <2001/06/20 23:03:30 samuel>
 *   Time-stamp: <2003/04/04 16:27:46 samuel>
 *   
 *	<performance.S>
 *	
 *	
 *   
 *   Copyright (C) 2001, 2002, 2003 Samuel Rydh (samuel@ibrium.se)
 *   
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation
 *   
 */

#include "mol_config.h"
#include "asmdefs.h"
#include "processor.h"
#include "osi.h"
		
mDEFINE(TEST_, [text, code], [
	li	r9,1
1:	.align	4
	nop
	nop
	mtctr	r9
	mftb	r10
2:
	.irp nn,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15 ;
	_code
	.endr
	bdnz	2b
	
	mftb	r11
	cmpwi	r9,1
	li	r9,10240
	beq	1b
	.data
4:	.ascii  "_text[]\0"
	.balign	4
	.text
3:	LOADI	r3,4b
	sub	r4,r11,r10
	bl	perf_print
])
mDEFINE(TEST,[code],[TEST_(_code,_code)])		

.macro PRINT str
	.data
10:	.ascii "\str\n\0"
	.balign 4
	.text
	LOADI	r3,10b
	bl	printm
.endm	

	
/************************************************************************/
/*	Test the implementation speed					*/
/************************************************************************/

GLOBL(performance):
	// r6-r8 unmodified by PRE/POST	
	mflr	r0
	stwu	r1,-16(r1)
	stw	r0,20(r1)

	PRINT "--------------- USER MODE ------------------"
	TEST([	addi	R3,R3,1		]);
	TEST([	nop			]);
	TEST([	li R0,0			]);
	TEST([	lwz R3,0(0)		]);

	TEST([	lfd	3,0(0)		]);
	TEST([	stfd	3,0(0)		]);
	TEST([	44: b	44b + 4		]);
	TEST([	mftb	R3		]);
	TEST([	mfctr	R3		]);
	TEST([	mtlr	R3		]);
	TEST([	mflr	R3		]);
	TEST([	mfcr	R3		]);
	TEST([	mtcrf	1,R3		]);
	TEST([	isync			]);
	TEST([	sync			]);
	TEST_([	lwarx + stwcx		],
	[
		lwarx	3,0,0
		stwcx.	3,0,0
	])
	TEST_([	lwzx + stwx		],
	[
		lwzx	3,0,0
		stwx	4,0,0
	])

	PRINT "------------ PRIVILEGED MODE ---------------"
	TEST([	mfmsr	R3		]);
	TEST([	tlbie	R3	 	]);
	TEST([	tlbsync			]);
	TEST([	mfsr	R3,0		]);
	TEST([	mtsr	0,R3		]);
	TEST([	mfsrin	R3,R4		]);
	TEST([	mtsrin	R3,R4		]);
	TEST([	mtsrr1  R3		]);
	TEST([	mfsrr1  R3		]);
	TEST([	mfdec	R3		]);
	TEST([	mtdec	R3		]);
	TEST([	mtdbatu	0,R3		]);
	TEST([	mtdbatl	0,R3		]);
	TEST([	mtibatl	0,R3		]);
	TEST([	mtibatu	0,R3		]);
	TEST([	mfspr R3,HID0	 	]);
	TEST([	mtspr HID0,R3	 	]);
	TEST([	mfspr R3,HID1	 	]);
	TEST([	mfspr R3,DABR	 	]);

	PRINT "---------------- MISC ----------------------"
	li	r3,(15 << 2) | 3	/* 2 MB, Vu, Vp */
	li	r4,2			/* r/w */
	mtdbatu	0,r3
	mtdbatl	0,r4
	mtibatu	0,r3
	mtibatl	0,r4
	
	lis	r3,0x10
	mtsdr1	r3
	li	r4,MSR_DR | MSR_IR
	mtmsr	r4
	TEST_([	load PTE		],[
		lwz R5,0(R3)
	]);	
	lis	r3,0x10
	TEST_([	store PTE (stw)		],[
		stw R5,0(R3)
	]);
	lis	r3,0x10	
	TEST_([	store PTE (stwx)	],[
		stwx R5,0,R3
	]);

	// test that lwarx/stwcx. works
	lis	r3,0x10	
1:	lwarx	r5,0,r3
	stwcx.	r5,0,r3
	bne-	1b

	// -------------- SPLITMODE -------------
	li	r4,MSR_DR
	mtmsr	r4

	li	r3,0
	TEST_([	splitmode - lwz		],[
		lwz R5,0(R3)
	]);	
	li	r3,0
	TEST_([	splitmode - dcbz	],[
		dcbz 0,R3
	]);
	TEST_([	splitmode - dcbst	],[
		dcbst 0,R3
	]);	

	// check that stwcx/lwarx pairs work in splitmode
	li	r3,0
1:	lwarx	r5,0,r3
	stwcx.	r5,0,r3
	bne-	1b

	li	r4,0		
	mtmsr	r4
			
	// --------------- EXIT ----------------

	lwz	r0,20(r1)
	addi	r1,r1,16
	mtlr	r0
	blr
