/* 
 *   Creation Date: <2001/06/11 22:41:04 samuel>
 *   Time-stamp: <2003/03/23 01:11:27 samuel>
 *   
 *	<selftest.c>
 *	
 *	This piece of code is run inside MOL. That is, it is
 *	not linked against glibc.
 *   
 *   Copyright (C) 2001, 2002, 2003 Samuel Rydh (samuel@ibrium.se)
 *   
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation
 *   
 */

#include "mol_config.h"
#include <stdarg.h>
#include "osi_calls.h"

extern void	performance( void );
extern int	entry( void );
extern void	perf_print( char *str, ulong count );


/************************************************************************/
/*	F U N C T I O N S						*/
/************************************************************************/

static int	mticks;

int
entry( void )
{
	printm(" *******************************************\n"
	       " *             Testing performance         *\n"
	       " *******************************************\n\n");
	mticks = OSI_UsecsToMticks(1000000);
	//printm("mticks = %d\n", mticks );
	performance();

	printm("\n *******************************************\n"
	         " *          Self-test successful           *\n"
	         " *******************************************\n\n");
	return 0;
}

void
perf_print( char *str, ulong elapsed )
{
	static int calibration=0;
	ulong v, vv;

	if( !calibration )
		calibration = elapsed;

	v = (ulong)(163.840 * (double)mticks / (double)(elapsed) + 0.5);
	vv = 10000.0 * (double)calibration / (double)elapsed + 0.5;
	printm(" %-19s %4ld.%ld MHz,  %3ld.%02ld %%\n", str, 
	       v/1000, (v/100) % 10,
	       vv/100, vv%100 );
}
